/* -*- C++ -*-
 *
 * ---------------------------------------------------------------------
 * $Id: testexceptions.cpp 600 2018-08-22 16:14:36Z cag $
 * ---------------------------------------------------------------------
 *
 * Copyright (C)  Niv Drory <drory@mpe.mpg.de>
 *                         Claus A. Goessl <cag@usm.uni-muenchen.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 *
 * ---------------------------------------------------------------------
 *
 */

#include <ltl/misc/exceptions.h>
#include <ltl/util/u_exception.h>

#include <iostream>
#include <exception>
#include <string>

using namespace ltl;
using namespace util;

void testing(const std::string method)
{
   std::cerr << "testing " << method << " ... ";
   std::cerr.flush();
}
void show_ok(const bool is_ok)
{
   if(!is_ok)
      std::cerr << "not ";
   std::cerr << "ok" << std::endl;
}


int main(int argc, char **argv)
{
   bool ok = false;
   testing("std::exception");
   try
   {
      throw std::exception();
   }
   catch(std::exception& e)
   {
      ok = true;
   }
   catch(...)
   {
      std::cerr << "something else and " << std::endl;
   }   
   show_ok(ok);

   ok = false;
   testing("ltl::FitsException");
   try
   {
      throw FitsException("fits exception");
   }
   catch(FitsException fe)
   {
      ok = true;
   }
   show_ok(ok);

   ok = false;
   testing("util::UException");
   try
   {
      throw UTDateException("util exception");
   }
   catch(UTDateException ue)
   {
      ok = true;
   }
   show_ok(ok);

   ok = false;
   testing("util::UTDateException");
   try
   {
      throw UTDateException("utdate exception");
   }
   catch(UTDateException utde)
   {
      ok = true;
   }
   show_ok(ok);

   ok = false;
   testing("util::StringException");
   try
   {
      throw UTDateException("utdate exception");
   }
   catch(UTDateException utde)
   {
      ok = true;
   }
   show_ok(ok);

   return 0;
}
